#include "stdafx.h"
#include "EpgView.h"
#include "resource.h"

CEpgView::CEpgView(void)
{
	m_hWnd = NULL;
	m_wServiceID = 0;
	m_pstProg = NULL;
	m_iNum = 0;
}

CEpgView::~CEpgView(void)
{
}

INT_PTR CEpgView::ShowModal(HINSTANCE hInst,int iResource,HWND hParentWnd)
{
	return DialogBoxParam(hInst,MAKEINTRESOURCE(iResource),hParentWnd,(DLGPROC)_EpgDlg,(LPARAM)this);
}

// tB^p_CAO
LRESULT CEpgView::EpgDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	CEpgView* pThis=this;

	switch (message)
	{
	case WM_INITDIALOG:
		{
			m_hWnd=hDlg;
			OnInitDialog();
			return TRUE;
		}
		break;
	case WM_COMMAND:
		{
			switch(LOWORD(wParam))
			{
			case IDCANCEL:
				{
					EndDialog(hDlg,(INT_PTR)-1);
				}
				break;
			case IDC_SCHEDULE:
				{
					LRESULT sel = SendDlgItemMessage(hDlg,IDC_EPG_LIST,LB_GETCURSEL,0,0);
					if(sel==LB_ERR) break;
					sel = SendDlgItemMessage(hDlg,IDC_EPG_LIST,LB_GETITEMDATA,sel,0);
					if(sel==LB_ERR) break;
					EndDialog(hDlg,(INT_PTR)sel);
				}
				break;
			}
		}
		break;
	}
	return FALSE;
}

void CEpgView::OnInitDialog()
{
	SendDlgItemMessage(m_hWnd,IDC_EPG_LIST,LB_RESETCONTENT,0,0);

	if(!m_pstProg || m_iNum==0 )
	{
		EnableWindow(GetDlgItem(m_hWnd,IDC_EPG_LIST),FALSE);
		return;
	}
	int i;
	for(i=0;i<m_iNum;i++)
	{
		char buf[200];
		long year,month,day,hour,min,sec;
		int pos=0;
		CDateTime::ConvertFrom_MJD(m_pstProg[i].stStart.Date,year,month,day);
		CDateTime::ConvertFrom_TimeSec(m_pstProg[i].stStart.Time,hour,min,sec);
		if(m_pstProg[i].stStart.Time==TimeVal_Unknown)
		{
//			continue;
			pos+=wsprintf(buf+pos,"????/??/??(??) s - ");
		} else {
			pos+=wsprintf(buf+pos,"%04d/%02d/%02d(%s) %02d:%02d-",year,month,day,CDateTime::GetWeekDayString(m_pstProg[i].stStart.Date),hour,min);
			if(m_pstProg[i].dwDuration!=TimeVal_Unknown)
			{
				CDateTime::ConvertFrom_TimeSec(m_pstProg[i].stEnd.Time,hour,min,sec);
				pos+=wsprintf(buf+pos,"%02d:%02d",hour,min);
			} else {
				pos+=wsprintf(buf+pos," ",hour,min);
			}
		}
		pos+=wsprintf(buf+pos," [0x%04X] %s",m_pstProg[i].wEventID,m_pstProg[i].szTitle);
		LRESULT res=SendDlgItemMessage(m_hWnd,IDC_EPG_LIST,LB_ADDSTRING,0,(LPARAM)buf);
		SendDlgItemMessage(m_hWnd,IDC_EPG_LIST,LB_SETITEMDATA,res,i);
	}
}